﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.WinControls.UI;

namespace SchedulerCustomAppointmentsResources
{
    class AppointmentWithEmail : Appointment
    {
        private string email = string.Empty;

        public string Email
        {
            get
            {
                return this.email;
            }
            set
            {
                if (this.email != value)
                {
                    this.email = value;
                    this.OnPropertyChanged("Email");
                }
            }
        }

        protected override Event CreateOccurrenceInstance()
        {
            AppointmentWithEmail occurrence = new AppointmentWithEmail();
            occurrence.email = this.email;
            return occurrence;
        }
    }

    class CustomAppointmentFactory : IAppointmentFactory
    {
        public IEvent CreateNewAppointment()
        {
            return new AppointmentWithEmail();
        }
    }
}