﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.UI.Scheduler.Dialogs;

namespace SchedulerCustomAppointmentsResources
{
    public partial class CustomEditAppointmentDialog : EditAppointmentDialog
    {
        Form1 mainForm;

        public CustomEditAppointmentDialog(Form1 mainForm)
        {
            InitializeComponent();
            this.mainForm = mainForm;
        }

        protected override void LoadSettingsFromEvent(IEvent ev)
        {
            base.LoadSettingsFromEvent(ev);

            AppointmentWithEmail appointmentWithEmail = ev as AppointmentWithEmail;
            if (appointmentWithEmail != null)
            {
                this.txtEmail.Text = appointmentWithEmail.Email;
            }
        }

        protected override void ApplySettingsToEvent(IEvent ev)
        {
            AppointmentWithEmail appointmentWithEmail = ev as AppointmentWithEmail;
            if (appointmentWithEmail != null)
            {
                appointmentWithEmail.Email = this.txtEmail.Text;
            }
            base.ApplySettingsToEvent(ev);
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            base.OnClosing(e);
            if (this.DialogResult == System.Windows.Forms.DialogResult.OK && mainForm != null)
            {
                mainForm.SaveData();
            }
        }
    }
}