﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace SchedulerCustomAppointmentsResources
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.radScheduler1.AppointmentFactory = new CustomAppointmentFactory();
            SchedulerBindingDataSource dataSource = this.schedulerBindingDataSource1;
            dataSource.EventProvider.AppointmentFactory = this.radScheduler1.AppointmentFactory;

            AppointmentMappingInfo appointmentMappingInfo = (AppointmentMappingInfo)dataSource.EventProvider.Mapping;
            appointmentMappingInfo.Mappings.Add(new SchedulerMapping("Email", "Email"));
            appointmentMappingInfo.Start = "Start";
            appointmentMappingInfo.End = "End";
            appointmentMappingInfo.Summary = "Summary";
            appointmentMappingInfo.Description = "Description";
            appointmentMappingInfo.Location = "Location";
            appointmentMappingInfo.BackgroundId = "BackgroundID";
            appointmentMappingInfo.StatusId = "StatusID";
            appointmentMappingInfo.RecurrenceRule = "RecurrenceRule";
            appointmentMappingInfo.Resources = "Appointments_AppointmentsResources";
            appointmentMappingInfo.ResourceId = "ResourceID";
            appointmentMappingInfo.Exceptions = "Appointments_Appointments";
            appointmentMappingInfo.MasterEventId = "ParentID";
            ResourceMappingInfo resourceMappingInfo = new ResourceMappingInfo();
            resourceMappingInfo.Id = "ID";
            resourceMappingInfo.Name = "ResourceName";
            schedulerBindingDataSource1.ResourceProvider.Mapping = resourceMappingInfo;
            schedulerBindingDataSource1.EventProvider.DataSource = this.dataFlowSchedDataSet.Appointments;
            schedulerBindingDataSource1.ResourceProvider.DataSource = this.dataFlowSchedDataSet.Resources;

            this.radScheduler1.DataSource = dataSource;

            schedulerBindingDataSource1.EventProvider.Mapping = appointmentMappingInfo;
            // TODO: This line of code loads data into the 'dataFlowSchedDataSet.Resources' table. You can move, or remove it, as needed.
            this.resourcesTableAdapter.Fill(this.dataFlowSchedDataSet.Resources);
            // TODO: This line of code loads data into the 'dataFlowSchedDataSet.AppointmentsResources' table. You can move, or remove it, as needed.
            this.appointmentsResourcesTableAdapter.Fill(this.dataFlowSchedDataSet.AppointmentsResources);
            // TODO: This line of code loads data into the 'dataFlowSchedDataSet.Appointments' table. You can move, or remove it, as needed.
            this.appointmentsTableAdapter.Fill(this.dataFlowSchedDataSet.Appointments);

            AppointmentBackgroundInfo abi = new AppointmentBackgroundInfo( 123, "Test", Color.LightCoral,Color.Coral ,Color.Black,Color.Black );
            abi.GradientStyle = Telerik.WinControls.GradientStyles.Solid;
            this.radScheduler1.Backgrounds.Add(abi);
            this.radScheduler1.Appointments.Last().BackgroundId =123;
            this.radScheduler1.ViewElement.UpdateAppointmentElements();
        }

        private void radScheduler1_AppointmentEditDialogShowing(object sender, AppointmentEditDialogShowingEventArgs e)
        {
            e.AppointmentEditDialog = new CustomEditAppointmentDialog(this);
        }

        public void SaveData()
        {
            appointmentsResourcesTableAdapter.Adapter.AcceptChangesDuringUpdate = false;
            
            DataFlowSchedDataSet.AppointmentsResourcesDataTable deletedRelationRecords =
                this.dataFlowSchedDataSet.AppointmentsResources.GetChanges(DataRowState.Deleted)
                as DataFlowSchedDataSet.AppointmentsResourcesDataTable;

            DataFlowSchedDataSet.AppointmentsResourcesDataTable newRelationRecords =
                this.dataFlowSchedDataSet.AppointmentsResources.GetChanges(DataRowState.Added)
                as DataFlowSchedDataSet.AppointmentsResourcesDataTable;

            DataFlowSchedDataSet.AppointmentsResourcesDataTable modifiedRelationRecords =
                this.dataFlowSchedDataSet.AppointmentsResources.GetChanges(DataRowState.Modified)
                as DataFlowSchedDataSet.AppointmentsResourcesDataTable;

            DataFlowSchedDataSet.AppointmentsDataTable newAppointmentRecords =
                this.dataFlowSchedDataSet.Appointments.GetChanges(DataRowState.Added) as DataFlowSchedDataSet.AppointmentsDataTable;

            DataFlowSchedDataSet.AppointmentsDataTable deletedAppointmentRecords =
                this.dataFlowSchedDataSet.Appointments.GetChanges(DataRowState.Deleted) as DataFlowSchedDataSet.AppointmentsDataTable;

            DataFlowSchedDataSet.AppointmentsDataTable modifiedAppointmentRecords =
                this.dataFlowSchedDataSet.Appointments.GetChanges(DataRowState.Modified) as DataFlowSchedDataSet.AppointmentsDataTable;

            try
            {
                if (newAppointmentRecords != null)
                {
                    Dictionary<int, int> newAppointmentIds = new Dictionary<int, int>();
                    Dictionary<object, int> oldAppointmentIds = new Dictionary<object, int>();

                    for (int i = 0; i < newAppointmentRecords.Count; i++)
                    {
                        oldAppointmentIds.Add(newAppointmentRecords[i], newAppointmentRecords[i].ID);
                    }

                    appointmentsTableAdapter.Update(newAppointmentRecords);

                    for (int i = 0; i < newAppointmentRecords.Count; i++)
                    {
                        newAppointmentIds.Add(oldAppointmentIds[newAppointmentRecords[i]], newAppointmentRecords[i].ID);
                    }

                    for (int i = 0; i < newRelationRecords.Count; i++)
                    {
                        newRelationRecords[i].AppointmentID = newAppointmentIds[newRelationRecords[i].AppointmentID];
                    }
                }

                if (deletedRelationRecords != null)
                {
                    appointmentsResourcesTableAdapter.Update(deletedRelationRecords);
                }

                if (deletedAppointmentRecords != null)
                {
                    appointmentsTableAdapter.Update(deletedAppointmentRecords);
                }
                if (modifiedAppointmentRecords != null)
                {
                    appointmentsTableAdapter.Update(modifiedAppointmentRecords);
                }

                if (newRelationRecords != null)
                {
                    appointmentsResourcesTableAdapter.Update(newRelationRecords);
                }
                if (modifiedRelationRecords != null)
                {
                    appointmentsResourcesTableAdapter.Update(modifiedRelationRecords);
                }

                this.dataFlowSchedDataSet.AcceptChanges();
            }
            catch (Exception ex)
            {
                MessageBox.Show(string.Format("An error occurred during the update process:\n{0}", ex.Message));
            }
            finally
            {
                if (deletedRelationRecords != null)
                {
                    deletedRelationRecords.Dispose();
                }
                if (newRelationRecords != null)
                {
                    newRelationRecords.Dispose();
                }
                if (modifiedRelationRecords != null)
                {
                    modifiedRelationRecords.Dispose();
                }
            }
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            SaveData();
        }
    }
}